///--------------------------------------------------------------------------------------
//	SWGameUtils.h
//
//	Portions are copyright:  1991-94 Tony Myles, All rights reserved worldwide.
//
//	Description:	some utility functions for games
///--------------------------------------------------------------------------------------


#ifndef __SWGAMEUTILS__
#define __SWGAMEUTILS__

#ifndef __QUICKDRAW__
#include <QuickDraw.h>
#endif

#ifndef __SOUND__
#include <Sound.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif


void		Randomize( void );
short		GetRandom(short min, short max);
UInt16		GetUnsignedRandom(UInt16 min, UInt16 max);
void		CenterRect(Rect* rectA, Rect* rectB);
void		AlignRect(Rect* rectP);
Boolean		ResourceExists(ResType resourceType, short resID);
void		AllowKeyUpEvents( void );
void		RestoreEventMask( void );

RgnHandle	SWHideMenuBar(GrafPtr grafPort);
void 		KeepMenuBarHidden(GrafPtr grafPort);
void		SWShowMenuBar(GrafPtr grafPort);

short		GetDepthFromGlobalRect( Rect* globalRect );
short		GetDepthFromWindow( WindowPtr theWindow );
short		GetGDeviceDepth( GDHandle theGDH );
void		RestoreSystemPalette( void );
Boolean		HasSystem7( void );

void		HideControlStrip(void);
void		RestoreControlStrip(void);

#ifdef __cplusplus
}
#endif


#endif /* __SWGAMEUTILS__ */
